%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function [Axis_Point_1, Axis_Point_2, Axis_vector] = Get_Fastener_Axis(Fastener_Index)

% Axis_Point_1 - всегда первый узел стержня болта
% Axis_vector - всегда направлен от последнего узла стержня болта к первому узлу стержня болта

global ErrCode;

global DB_FASTENERS;

global DB_NODES;
global AT_NODES;

Axis_Point_1 = [];
Axis_Point_2 = [];
Axis_vector = [];

% Если болт нулевой длины
if (Equiv_Check_Cube(DB_FASTENERS{Fastener_Index}.Shank_nodes(1), DB_FASTENERS{Fastener_Index}.Shank_nodes(size(DB_FASTENERS{Fastener_Index}.Shank_nodes,1))))
    
    % Вычисление средней нормали первого яруса
    switch DB_FASTENERS{Fastener_Index}.Joint_topology{1}

        case {'plate', 'rbe2_2d_hole', 'bar_spider_2d_hole', 'plate_rbe2_sequential', 'plate_rbe2_parallel'}

            Average_normal_1 = Get_Plate_Normal(Fastener_Index, 1);

            if (ErrCode < 0)
                return;
            end

        case {'rbe2_3d_hole', 'bar_spider_3d_hole'}

            fprintf (1, '\nОшибка: обнаружен тип присоединенной топологии [%s] в болте нулевой длины с номером %i !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{1}, Fastener_Index);
            fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
            ErrCode = -1;
            return;

        otherwise

            fprintf (1, '\nОшибка функции Get_Fastener_Axis: неизвестный тип присоединенной топологии [%s] в болте %i !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{1}, Fastener_Index);
            ErrCode = -1;
            return;

    end

    % Вычисление средней нормали последнего яруса
    switch DB_FASTENERS{Fastener_Index}.Joint_topology{DB_FASTENERS{Fastener_Index}.N_layers}

        case {'plate', 'rbe2_2d_hole', 'bar_spider_2d_hole', 'plate_rbe2_sequential', 'plate_rbe2_parallel'}

            Average_normal_2 = Get_Plate_Normal(Fastener_Index, DB_FASTENERS{Fastener_Index}.N_layers);

            if (ErrCode < 0)
                return;
            end

        case {'rbe2_3d_hole', 'bar_spider_3d_hole'}

            fprintf (1, '\nОшибка: обнаружен тип присоединенной топологии [%s] в болте нулевой длины с номером %i !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{DB_FASTENERS{Fastener_Index}.N_layers}, Fastener_Index);
            fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
            ErrCode = -1;
            return;

        otherwise

            fprintf (1, '\nОшибка функции Get_Fastener_Axis: неизвестный тип присоединенной топологии [%s] в болте %i !\n', DB_FASTENERS{Fastener_Index}.Joint_topology{DB_FASTENERS{Fastener_Index}.N_layers}, Fastener_Index);
            ErrCode = -1;
            return;

    end

    % Обращение второй нормали, если она не сонаправлена с первой
    Average_normal_2 = Average_normal_2 * sign(dot(Average_normal_1, Average_normal_2));

    % Вычисление средней нормали, которая принимается в качестве оси болта
    Axis_vector = (Average_normal_1 + Average_normal_2) / norm(Average_normal_1 + Average_normal_2);
    
    Axis_Point_1 = DB_NODES{AT_NODES(DB_FASTENERS{Fastener_Index}.Shank_nodes(1))}.Location;
    Axis_Point_2 = Axis_Point_1 - 10*Axis_vector;
    
else
    
    Axis_Point_1 = DB_NODES{AT_NODES(DB_FASTENERS{Fastener_Index}.Shank_nodes(1))}.Location;
    Axis_Point_2 = DB_NODES{AT_NODES(DB_FASTENERS{Fastener_Index}.Shank_nodes(size(DB_FASTENERS{Fastener_Index}.Shank_nodes,1)))}.Location;
    Axis_vector = (Axis_Point_1 - Axis_Point_2) / norm(Axis_Point_1 - Axis_Point_2);
    
end
